package log

import (
	"sync"

	"go.uber.org/zap"
)

var (
	Logger *zap.Logger
	locker = &sync.Mutex{}
)

func init() {
	var err error
	config := zap.NewProductionConfig()
	Logger, err = config.Build()
	if err != nil {
		panic(err)
	}
}

func Debug() {
	var err error

	config := zap.NewProductionConfig()
	config.Level = zap.NewAtomicLevelAt(zap.DebugLevel)

	locker.Lock()
	defer locker.Unlock()

	Logger, err = config.Build()
	if err != nil {
		panic(err)
	}
}
